## ros-melodic-costmap-2d 1.16.7

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(costmap_2d)

find_package(catkin REQUIRED
        COMPONENTS
            cmake_modules
            dynamic_reconfigure
            geometry_msgs
            laser_geometry
            map_msgs
            message_filters
            message_generation
            nav_msgs
            pluginlib
            roscpp
            sensor_msgs
            std_msgs
            tf2
            tf2_geometry_msgs
            tf2_ros
            tf2_sensor_msgs
            visualization_msgs
            voxel_grid
        )

find_package(Eigen3 REQUIRED)
find_package(Boost REQUIRED COMPONENTS system thread)
include_directories(
    include
    ${catkin_INCLUDE_DIRS}
    ${EIGEN3_INCLUDE_DIRS}
    ${Boost_INCLUDE_DIRS}
)

add_definitions(${EIGEN3_DEFINITIONS})

# messages
add_message_files(
    DIRECTORY msg
    FILES
    VoxelGrid.msg
)

generate_messages(
    DEPENDENCIES
        std_msgs
        geometry_msgs
        map_msgs
)

# dynamic reconfigure
generate_dynamic_reconfigure_options(
  cfg/Costmap2D.cfg
  cfg/ObstaclePlugin.cfg
  cfg/GenericPlugin.cfg
  cfg/InflationPlugin.cfg
  cfg/VoxelPlugin.cfg
)

catkin_package(
    INCLUDE_DIRS
        include
        ${EIGEN3_INCLUDE_DIRS}
    LIBRARIES costmap_2d layers
    CATKIN_DEPENDS
        dynamic_reconfigure
        geometry_msgs
        laser_geometry
        map_msgs
        message_filters
        message_runtime
        nav_msgs
        pluginlib
        roscpp
        sensor_msgs
        std_msgs
        tf2_ros
        visualization_msgs
        voxel_grid
    DEPENDS
        EIGEN3
        Boost
)

add_library(costmap_2d
  src/array_parser.cpp
  src/costmap_2d.cpp
  src/observation_buffer.cpp
  src/layer.cpp
  src/layered_costmap.cpp
  src/costmap_2d_ros.cpp
  src/costmap_2d_publisher.cpp
  src/costmap_math.cpp
  src/footprint.cpp
  src/costmap_layer.cpp
)
add_dependencies(costmap_2d ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
target_link_libraries(costmap_2d
  ${Boost_LIBRARIES}
  ${catkin_LIBRARIES}
)

add_library(layers
  plugins/inflation_layer.cpp
  plugins/obstacle_layer.cpp
  plugins/static_layer.cpp
  plugins/voxel_layer.cpp
  src/observation_buffer.cpp
)
add_dependencies(layers ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
target_link_libraries(layers
  costmap_2d
)

add_executable(costmap_2d_markers src/costmap_2d_markers.cpp)
add_dependencies(costmap_2d_markers ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
target_link_libraries(costmap_2d_markers
    costmap_2d
    ${Boost_LIBRARIES}
    ${catkin_LIBRARIES}
)

add_executable(costmap_2d_cloud src/costmap_2d_cloud.cpp)
add_dependencies(costmap_2d_cloud ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
target_link_libraries(costmap_2d_cloud
    costmap_2d
    ${Boost_LIBRARIES}
    ${catkin_LIBRARIES}
)

add_executable(costmap_2d_node src/costmap_2d_node.cpp)
add_dependencies(costmap_2d_node ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
target_link_libraries(costmap_2d_node
    costmap_2d
    ${Boost_LIBRARIES}
    ${catkin_LIBRARIES}
)

## Configure Tests
if(CATKIN_ENABLE_TESTING)
  # Find package test dependencies
  find_package(rostest REQUIRED)

  # Add the test folder to the include directories
  include_directories(test)

  # Create targets for test executables
  add_executable(costmap_tester EXCLUDE_FROM_ALL test/costmap_tester.cpp)
  add_dependencies(tests costmap_tester)
  target_link_libraries(costmap_tester costmap_2d ${GTEST_LIBRARIES})

  add_executable(footprint_tests EXCLUDE_FROM_ALL test/footprint_tests.cpp)
  add_dependencies(tests footprint_tests)
  target_link_libraries(footprint_tests costmap_2d ${GTEST_LIBRARIES})

  add_executable(obstacle_tests EXCLUDE_FROM_ALL test/obstacle_tests.cpp)
  add_dependencies(tests obstacle_tests)
  target_link_libraries(obstacle_tests costmap_2d layers ${GTEST_LIBRARIES})

  add_executable(static_tests EXCLUDE_FROM_ALL test/static_tests.cpp)
  add_dependencies(tests static_tests)
  target_link_libraries(static_tests costmap_2d layers ${GTEST_LIBRARIES})

  add_executable(inflation_tests EXCLUDE_FROM_ALL test/inflation_tests.cpp)
  add_dependencies(tests inflation_tests)
  target_link_libraries(inflation_tests costmap_2d layers ${GTEST_LIBRARIES})

  catkin_download_test_data(${PROJECT_NAME}_simple_driving_test_indexed.bag
    http://download.ros.org/data/costmap_2d/simple_driving_test_indexed.bag
    DESTINATION ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/test
    MD5 61168cff9425b11e093ea3a627c81c8d)
  catkin_download_test_data(${PROJECT_NAME}_willow-full-0.025.pgm
    http://download.ros.org/data/costmap_2d/willow-full-0.025.pgm
    DESTINATION ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/test
    MD5 e66b17ee374f2d7657972efcb3e2e4f7)

  add_rostest(test/footprint_tests.launch)
  add_rostest(test/inflation_tests.launch)
  add_rostest(test/obstacle_tests.launch)
  add_rostest(test/simple_driving_test.xml)
  add_rostest(test/static_tests.launch)

  catkin_add_gtest(array_parser_test test/array_parser_test.cpp)
  target_link_libraries(array_parser_test costmap_2d)

  catkin_add_gtest(coordinates_test test/coordinates_test.cpp)
  target_link_libraries(coordinates_test costmap_2d)
endif()

install( TARGETS
    costmap_2d_markers
    costmap_2d_cloud
    costmap_2d_node
    DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(TARGETS
    costmap_2d
    layers
    ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
    LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
    RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION}
)

install(FILES costmap_plugins.xml
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

install(FILES test/TenByTen.yaml test/TenByTen.pgm
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/test
)


install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  PATTERN ".svn" EXCLUDE
)

=== debian/changelog ===
ros-melodic-costmap-2d (1.16.7-1bionic) bionic; urgency=high

  * add explicit call to ros::Timer::stop in the destructor (#984 <https://github.com/ros-planning/navigation/issues/984>)
    Co-authored-by: Dima Dorezyuk <mailto:dorezyuk@magazino.eu>
  * backport noetic memory fixes (#983 <https://github.com/ros-planning/navigation/issues/983>)
    spent some time with valgrind to fix this test,
    was failing intermittently in melodic, all the
    time in noetic.
  * Contributors: Dima Dorezyuk, Michael Ferguson

 -- David V. Lu!! <davidvlu@gmail.com>  Thu, 27 Aug 2020 04:00:00 -0000

ros-melodic-costmap-2d (1.16.6-1bionic) bionic; urgency=high



 -- David V. Lu!! <davidvlu@gmail.com>  Wed, 18 Mar 2020 04:00:00 -0000

ros-melodic-costmap-2d (1.16.5-1bionic) bionic; urgency=high

  * [melodic] updated install for better portability. (#973 <https://github.com/ros-planning/navigation/issues/973>)
  * Contributors: Sean Yen

 -- David V. Lu!! <davidvlu@gmail.com>  Sun, 15 Mar 2020 04:00:00 -0000

ros-melodic-costmap-2d (1.16.4-1bionic) bionic; urgency=high

  * fix published footprint topic name (#947 <https://github.com/cobalt-robotics/navigation/issues/947>)
    The default name of the topic will be updated in noetic
  * fix usage of size_locked, fixes #959 <https://github.com/cobalt-robotics/navigation/issues/959> (#966 <https://github.com/cobalt-robotics/navigation/issues/966>)
  * [Windows][melodic] Navigation (except for map_server and amcl) Windows build bring up (#851 <https://github.com/cobalt-robotics/navigation/issues/851>)
  * Merge pull request #957 <https://github.com/cobalt-robotics/navigation/issues/957> from Blindnology/melodic-updateOrigin
    Optimize costmap_2d::updateOrigin
  * Optimize costmap_2d::updateOrigin
  * Contributors: Michael Ferguson, Pavlo Kolomiiets, Sean Yen, Yuki Furuta

 -- David V. Lu!! <davidvlu@gmail.com>  Wed, 04 Mar 2020 05:00:00 -0000

ros-melodic-costmap-2d (1.16.3-1bionic) bionic; urgency=high

  * Merge pull request #877 <https://github.com/ros-planning/navigation/issues/877> from SteveMacenski/layer_clear_area-melodic
    [melodic] moving clearing area method to costmap_layer so other applications can clear other types.
  * Merge branch 'melodic-devel' into layer_clear_area-melodic
  * Drop Parameter Magic (#893 <https://github.com/ros-planning/navigation/issues/893>)
  * Fixes #782 <https://github.com/ros-planning/navigation/issues/782> (#892 <https://github.com/ros-planning/navigation/issues/892>)
  * Costmap_2d plugin universal parameters and pre-hydro warnings (#738 <https://github.com/ros-planning/navigation/issues/738>)
    * Comment and description clarification
    * Renamed resetOldParameters to loadOldParameters
    * Upscaled pre-hydro parameter info message to warning and added costmap-name
    * Warn user when static_map or map_type is set but not used while plugins are used
    * Added function that copies parent parameters inside each layer (makes it possible to set a global inflation_radius)
    * use parameter magic
  * Changed logic for when to resize layered costmap in static layer (#792 <https://github.com/ros-planning/navigation/issues/792>)
    * Changed logic for when to resize layered costmap in static layer
    -Now the master layered costmap should no longer get resized when
    isSizeLocked returns true
    * Fixing format for if loop
  * clear area in layer for melodic
  * [kinetic] Fix Bounds Bug (plus test) (#871 <https://github.com/ros-planning/navigation/issues/871>) (#875 <https://github.com/ros-planning/navigation/issues/875>)
    * fix map bounds bug
    * Add test
  * Fix install (#855 <https://github.com/ros-planning/navigation/issues/855>)
  * Add additional linked libraries (#803 <https://github.com/ros-planning/navigation/issues/803>)
  * Contributors: David V. Lu!!, Martin Ganeff, Michael Ferguson, Steven Macenski, stevemacenski

 -- David V. Lu!! <davidvlu@gmail.com>  Fri, 15 Nov 2019 05:00:00 -0000

ros-melodic-costmap-2d (1.16.2-1bionic) bionic; urgency=high

  * Merge pull request #773 <https://github.com/ros-planning/navigation/issues/773> from ros-planning/packaging_fixes
    packaging fixes
  * update costmap_2d cmake
    * explicit dependency on tf2
    * remove old PCL disable crap
  * Contributors: Michael Ferguson

 -- David V. Lu!! <davidvlu@gmail.com>  Tue, 31 Jul 2018 04:00:00 -0000

ros-melodic-costmap-2d (1.16.1-1bionic) bionic; urgency=high

  * Merge pull request #770 <https://github.com/ros-planning/navigation/issues/770> from ros-planning/fix_debians
    Fix debian builds (closes #769 <https://github.com/ros-planning/navigation/issues/769>)
  * add tf2_geometry_msgs depend to costmap_2d
  * Contributors: Michael Ferguson

 -- David V. Lu!! <davidvlu@gmail.com>  Sat, 28 Jul 2018 04:00:00 -0000

ros-melodic-costmap-2d (1.16.0-1bionic) bionic; urgency=high

  * Switch to TF2 #755 <https://github.com/ros-planning/navigation/issues/755>
  * unify combination_method dynamic reconfig, closes #402 <https://github.com/ros-planning/navigation/issues/402>
  * Merge pull request #723 <https://github.com/ros-planning/navigation/issues/723> from moriarty/melodic-buildfarm-errors
    Melodic buildfarm errors
  * [costmap_2d/test] set empty transform to Identity
  * fix test: abs(unsigned int) is ambiguous
    Instead, compare values and subtract smaller from larger to find
    the dx and dy.
  * fixes pluginlib deprecated header warnings
  * Merge pull request #694 <https://github.com/ros-planning/navigation/issues/694> from ros-planning/lunar_691
    costmap variable init & cleanup (forward port of #691 <https://github.com/ros-planning/navigation/issues/691>)
  * remove unused got_footprint_
  * initialize all costmap variables
  * Merge pull request #686 <https://github.com/ros-planning/navigation/issues/686> from ros-planning/lunar_675
    Fixed race condition with costmaps in LayeredCostmap::resizeMap()
  * Fixed race condition with costmaps in LayeredCostmap::resizeMap()


=== debian/control ===
Source: ros-melodic-costmap-2d
Section: misc
Priority: optional
Maintainer: David V. Lu!! <davidvlu@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-melodic-catkin, ros-melodic-cmake-modules, ros-melodic-dynamic-reconfigure, ros-melodic-geometry-msgs, ros-melodic-laser-geometry, ros-melodic-map-msgs, ros-melodic-map-server, ros-melodic-message-filters, ros-melodic-message-generation, ros-melodic-nav-msgs, ros-melodic-pluginlib, ros-melodic-rosbag, ros-melodic-roscpp, ros-melodic-rostest, ros-melodic-rosunit, ros-melodic-sensor-msgs, ros-melodic-std-msgs, ros-melodic-tf2, ros-melodic-tf2-geometry-msgs, ros-melodic-tf2-ros, ros-melodic-tf2-sensor-msgs, ros-melodic-visualization-msgs, ros-melodic-voxel-grid
Homepage: http://wiki.ros.org/costmap_2d
Standards-Version: 3.9.2

Package: ros-melodic-costmap-2d
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-melodic-dynamic-reconfigure, ros-melodic-geometry-msgs, ros-melodic-laser-geometry, ros-melodic-map-msgs, ros-melodic-message-filters, ros-melodic-message-runtime, ros-melodic-nav-msgs, ros-melodic-pluginlib, ros-melodic-rosconsole, ros-melodic-roscpp, ros-melodic-rostest, ros-melodic-sensor-msgs, ros-melodic-std-msgs, ros-melodic-tf2, ros-melodic-tf2-ros, ros-melodic-visualization-msgs, ros-melodic-voxel-grid
Description: This package provides an implementation of a 2D costmap that takes in sensor data from the world, builds a 2D or 3D occupancy grid of the data (depending on whether a voxel based implementation is used), and inflates costs in a 2D costmap based on the occupancy grid and a user specified inflation radius.
 This package also provides support for map_server based initialization of a costmap, rolling window based costmaps, and parameter based subscription to and configuration of sensor topics.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-costmap-2d//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install
